/* Tabela OPERGRUPOP: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela OPERGRUPOP */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela OPERGRUPOP, utilizando
a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_AUTGRUPOP
AFTER DELETE OR INSERT OR UPDATE
ON AUTGRUPOP FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   IF DELETING THEN

      IF :OLD.IDAUTGRUPOP IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.IDAUTGRUPOP;
      END IF;

      IF :OLD.NRAUTGRUPOP IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.NRAUTGRUPOP;
      END IF;
      IF :OLD.CDSETOR IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.CDSETOR;
      END IF;
      IF :OLD.DTULTATUAGOP IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.DTULTATUAGOP;
      END IF;

      IF :OLD.CDGRUPOPER IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.CDGRUPOPER;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDGRUPOPER||:OLD.IDAUTGRUPOP||:OLD.NRAUTGRUPOP;
   ELSE
      IF UPDATING THEN
         IF NVL(:NEW.IDAUTGRUPOP,'') <> NVL(:OLD.IDAUTGRUPOP,'') OR
            NVL(:NEW.NRAUTGRUPOP,'') <> NVL(:OLD.NRAUTGRUPOP,'') OR
            NVL(:NEW.CDSETOR,'')     <> NVL(:OLD.CDSETOR,'')     OR
            NVL(:NEW.CDGRUPOPER,'')  <> NVL(:OLD.CDGRUPOPER,'')  THEN

            IF NVL(:NEW.IDAUTGRUPOP,'') <> NVL(:OLD.IDAUTGRUPOP,'') THEN
               V_DESC := V_DESC || ' IdAutGrup=' || :NEW.IDAUTGRUPOP;
            END IF;

            IF NVL(:NEW.NRAUTGRUPOP,'') <> NVL(:OLD.NRAUTGRUPOP,'') THEN
               V_DESC := V_DESC || ' NrAutGrup=' || :NEW.NRAUTGRUPOP;
            END IF;

            IF NVL(:NEW.CDSETOR,'')     <> NVL(:OLD.CDSETOR,'') THEN
               V_DESC := V_DESC || ' Setor=' || :NEW.CDSETOR;
            END IF;

            IF NVL(:NEW.CDGRUPOPER,'')  <> NVL(:OLD.CDGRUPOPER,'') THEN
               V_DESC := V_DESC || ' CodGrup=' || :NEW.CDGRUPOPER;
            END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDGRUPOPER||:OLD.IDAUTGRUPOP||:OLD.NRAUTGRUPOP;
         END IF;
      ELSE
         IF :NEW.IDAUTGRUPOP IS NOT NULL THEN
            V_DESC := V_DESC || ' IdAutGrup=' || :NEW.IDAUTGRUPOP;
         END IF;

         IF :NEW.NRAUTGRUPOP IS NOT NULL THEN
            V_DESC := V_DESC || ' NrAuGrup=' || :NEW.NRAUTGRUPOP;
         END IF;

         IF :NEW.CDSETOR IS NOT NULL THEN
            V_DESC := V_DESC || ' Setor=' || :NEW.CDSETOR;
         END IF;

         IF :NEW.CDGRUPOPER IS NOT NULL THEN
            V_DESC := V_DESC || ' CodGrup=' || :NEW.CDGRUPOPER;
         END IF;

         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDGRUPOPER||:NEW.IDAUTGRUPOP||:NEW.NRAUTGRUPOP;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('AUTGRUPOP',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_AUTGRUPOP','4.09.060'); END;
/



